const express = require('express');

function createRouter(db) {
    const router = express.Router();

    function isSession(req, res) {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'SELECT SessionName FROM Session WHERE SessionName = \''+spielname+'\';',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        return res.status(500).json({status: 'error'});
                    } else {
                        if (results.length > 0) {
                            return res.status(200).json({status: 'true'});
                        } else {
                            return res.status(200).json({status: 'false'});
                        }
                    }
                }
            );
        } else {
            return res.status(500).json({status: 'error'});
        }
    }

    // the routes are defined here

    //Generate new Session
    router.post('/addSession', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'INSERT INTO Session (SessionName) VALUES (\"'+spielname+'\");',
                error => {
                    if (error) {
                        console.error(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        //Init new Gamestatus
                        var redTurn = Math.random();
                        redTurn = Math.round(redTurn);
                        db.query(
                            'INSERT INTO Gamestatus (SessionID, Red, Blue, RedTurn, ActiveExplainer, ActiveWatchdog) VALUES ((SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\"), 0, 0, '+redTurn+', 0, 0);',
                            error => {
                                if (error) {
                                    console.error(error);
                                    res.status(500).json({status: 'false'});
                                } else {
                                    res.status(200).json({status: 'true'});
                                }
                            }
                        );
                    }
                }
            );
        } else {
            res.status(500).json({status: 'error'});
        }
    });

    //Check if Session exist
    router.post('/isSession', (req, res) => {
        isSession(req, res)
    });

    //Return all Sessions (Not neccesary)
    router.get('/Session', function (req, res) {
        db.query(
            'SELECT * FROM Session',
            (error, results) => {
                if (error) {
                    console.log(error);
                    res.status(500).json({status: 'error'});
                } else {
                    res.status(200).json(results);
                }
            }
        );
    });

    //Return GameStatus
    router.post('/getGamestatus', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'SELECT SessionID, Red, Blue, RedTurn, ActiveExplainer, ActiveWatchdog FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        res.status(200).json(
                            {
                                status: 'true',
                                sessionID: results[0].SessionID,
                                red: results[0].Red,
                                blue: results[0].Blue,
                                redTurn: results[0].RedTurn,
                                activeExplainer: results[0].ActiveExplainer,
                                activeWatchdog: results[0].ActiveWatchdog
                            }
                        );
                    }
                }
            );
        } else {
            res.status(500).json({status: 'error'});
        }
    });

    //Return S2C
    router.post('/getS2C', (req,res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            let card;
            db.query(
                'SELECT Card.CardID, Solution, Tabu1, Tabu2, Tabu3, Tabu4, Tabu5 \n' +
                'FROM Card \n' +
                'WHERE Card.CardID NOT IN \n' +
                '(\n' +
                ' SELECT S2C.CardID\n' +
                ' FROM S2C\n' +
                ' WHERE S2C.CardID IS NOT NULL AND S2C.SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")\n' +
                ');',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        console.log(results);
                        let random = Math.random() * (results.length-1);
                        random = Math.round(random)
                        card = results[random];
                        console.log(card);
                        db.query(
                          'INSERT INTO S2C (SessionID, CardID) VALUES ((SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\"), '+card.CardID+');',
                            (error, results) => {
                                if (error) {
                                    res.status(500).json({status: 'false'});
                                } else {
                                    res.status(200).json(
                                        {
                                            status: 'true',
                                            cardID: card.CardID,
                                            solution: card.Solution,
                                            tabu1: card.Tabu1,
                                            tabu2: card.Tabu2,
                                            tabu3: card.Tabu3,
                                            tabu4: card.Tabu4,
                                            tabu5: card.Tabu5,
                                        }
                                    );
                                }
                            }
                        );
                    }
                });
        } else {
            res.status(500).json({status: 'error'});
        }
    });

    //Start a new Round and lock the game positions
    router.post('/newRound', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'UPDATE Gamestatus SET ActiveExplainer = 1, ActiveWatchdog=1 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        res.status(200).json({status: 'true'});
                    }
                }
            );
        } else {
            res.status(500).json({status: 'false'});
        }
    });

    //End a Round and unlock the game positions and invert RedTurn
    router.post('/endRound', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'UPDATE Gamestatus SET RedTurn = (SELECT 1-Gamestatus.RedTurn FROM Gamestatus INNER JOIN Session ON Session.SessionID=Gamestatus.SessionID WHERE Session.SessionName = \"'+spielname+'\"),  ActiveExplainer = 0, ActiveWatchdog=0 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        res.status(200).json({status: 'true'});
                    }
                }
            );
        } else {
            res.status(500).json({status: 'false'});
        }
    });

    //Starts a new Game and resets red and blue and chooses a random value for RedTurn
    router.post('/newGame', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'UPDATE Gamestatus SET Red = 0, Blue = 0, RedTurn = '+Math.round(Math.random())+' WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        res.status(200).json({status: 'true'});
                    }
                }
            );
        } else {
            res.status(500).json({status: 'false'});
        }
    });

    //Add Point
    router.post('/addPoint', (req, res) => {
        console.log(req.body);
        const spielname = req.body.spielname;
        const team = req.body.team;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null && team.match(/^[0-9a-zA-Z]+$/) != null) {
            if (team === 'red') {
                db.query(
                    'UPDATE Gamestatus SET Red = 1+(SELECT Red FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.status(500).json({status: 'false'});
                        } else {
                            res.status(200).json(
                                {
                                    status: 'true',
                                    red: JSON.parse(req.body.red)+1,
                                    blue: req.body.blue
                                }
                            );
                        }
                    }
                );
            } else if (team === 'blue') {
                db.query(
                    'UPDATE Gamestatus SET Blue = 1+(SELECT Blue FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.status(500).json({status: 'false'});
                        } else {
                            res.status(200).json(
                                {
                                    status: 'true',
                                    red: req.body.red,
                                    blue: JSON.parse(req.body.blue)+1
                                }
                            );
                        }
                    }
                );
            }
        } else {
            res.status(500).json({status: 'false'});
        }
    });

    //Remove Point
    router.post('/removePoint', (req, res) => {
        console.log(req.body);
        const spielname = req.body.spielname;
        const team = req.body.team;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null && team.match(/^[0-9a-zA-Z]+$/) != null) {
            if (team === 'red') {
                db.query(
                    'UPDATE Gamestatus SET Red = -1+(SELECT Red FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.status(500).json({status: 'false'});
                        } else {
                            res.status(200).json(
                                {
                                    status: 'true',
                                    red: JSON.parse(req.body.red)-1,
                                    blue: req.body.blue
                                }
                            );
                        }
                    }
                );
            } else if (team === 'blue') {
                db.query(
                    'UPDATE Gamestatus SET Blue = -1+(SELECT Blue FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")) WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                    (error) => {
                        if (error) {
                            console.log(error);
                            res.status(500).json({status: 'false'});
                        } else {
                            res.status(200).json(
                                {
                                    status: 'true',
                                    red: req.body.red,
                                    blue: JSON.parse(req.body.blue)-1
                                }
                            );
                        }
                    }
                );
            }
        } else {
            res.status(500).json({status: 'false'});
        }
    });

    return router;

}

module.exports = createRouter;
